## ginac 1.6.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

project(GiNaC)
file(STRINGS ${CMAKE_SOURCE_DIR}/ginac/version.h _ginac_vinfo REGEX "^#define[\t ]+GINACLIB_.*_VERSION.*")
string(REGEX REPLACE "^.*GINACLIB_MAJOR_VERSION[ \t]+([0-9]+).*" "\\1" GINAC_MAJOR_VERSION "${_ginac_vinfo}")
string(REGEX REPLACE "^.*GINACLIB_MINOR_VERSION[ \t]+([0-9]+).*" "\\1" GINAC_MINOR_VERSION "${_ginac_vinfo}")
string(REGEX REPLACE "^.*GINACLIB_MICRO_VERSION[ \t]+([0-9]+).*" "\\1" GINAC_MICRO_VERSION "${_ginac_vinfo}")
set(GINAC_VERSION "${GINAC_MAJOR_VERSION}.${GINAC_MINOR_VERSION}.${GINAC_MICRO_VERSION}")

# Library versioning info
file(STRINGS ${CMAKE_SOURCE_DIR}/ginac/version.h _ginac_vinfo REGEX "^#define[\t ]+GINAC_LT_.*")
string(REGEX REPLACE "^.*GINAC_LT_CURRENT[ \t]+([0-9]+).*" "\\1" ginac_lt_current "${_ginac_vinfo}")
string(REGEX REPLACE "^.*GINAC_LT_AGE[ \t]+([0-9]+).*" "\\1" ginac_lt_age "${_ginac_vinfo}")
string(REGEX REPLACE "^.*GINAC_LT_REVISION[ \t]+([0-9]+).*" "\\1" ginac_lt_revision "${_ginac_vinfo}")
# XXX: it looks like we need to set this for every platform?
math(EXPR ginaclib_soversion "${ginac_lt_current} - ${ginac_lt_age}")
set(ginaclib_version ${ginaclib_soversion}.${ginac_lt_age}.${ginac_lt_revision})

# make check
enable_testing()
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})
# make info
add_custom_target(info ALL)
add_custom_target(html)
add_custom_target(pdf)

find_package(CLN 1.2.2 REQUIRED)
include_directories(${CLN_INCLUDE_DIR})

include(CheckIncludeFile)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("unistd.h" HAVE_UNISTD_H)

include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/ginac)

# This macro implements some very special logic how to deal with the cache.
# By default the various install locations inherit their value from their
#"parent" variable, so if you set CMAKE_INSTALL_PREFIX, then
# EXEC_INSTALL_PREFIX, BIN_INSTALL_DIR, LIB_INSTALL_DIR, etc will calculate
# their value by appending subdirs to CMAKE_INSTALL_PREFIX.
# This would work just fine without using the cache.
# But if somebody wants e.g. a different EXEC_INSTALL_PREFIX this value
# has to go into the cache, otherwise it will be forgotten on the next cmake
# run. Once a variable is in the cache, it doesn't depend on its "parent"
# variables anymore and you can only change it by editing it directly.
# This macro helps in this regard, because as long as you don't set one
# of the variables explicitly to some location, the value will be computed
# from parents of the variable in question. So modifying CMAKE_INSTALL_PREFIX
# later on will have the desired effect.
# But once you decide to set e.g. EXEC_INSTALL_PREFIX to some special
# location this will go into the cache and it will no longer depend on
# CMAKE_INSTALL_PREFIX.

macro(_set_fancy _var _value _comment)
	set(predefinedvalue "${_value}")
	if ("${CMAKE_INSTALL_PREFIX}" STREQUAL "${GINAC_INSTALL_DIR}" AND DEFINED GINAC_${_var})
		set(predefinedvalue "${GINAC_${_var}}")
	endif()
	if (NOT DEFINED ${_var})
		set(${_var} ${predefinedvalue})
	else()
		set(${_var} "${${_var}}" CACHE PATH "${_comment}")
	endif()
endmacro(_set_fancy)

_set_fancy(EXEC_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"
	   "Base directory for libraries and executables")
_set_fancy(LIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/lib"
	   "Libraries installation directory")
_set_fancy(BIN_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/bin"
	   "Binaries installation directory")
_set_fancy(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share"
	   "Base directory for architecture independent files")
_set_fancy(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include"
	   "Headers installation directory")

if (NOT DEFINED BUILD_SHARED_LIBS)
	if (NOT MSVC)
		set(BUILD_SHARED_LIBS true)
	else()
		set(BUILD_SHARED_LIBS false)
	endif()
endif()

# Set proper rpath so tools will Just Work(TM) after make install.
# Also take care to add -Wl,-rpath, stanza into the *.pc file so that
#
# g++ `pkg-config --cflags --libs ginac`
#
# will Just Work (TM), too.
# Distro packagers should use -DCMAKE_INSTALL_RPATH="" to avoid
# setting rpath on installed binaries.

# rpath for making binaries/libraries relocatable
set(_ginac_rpath_reloc "$ORIGIN/../lib")
set(_wl_rpath "${CMAKE_SHARED_LIBRARY_RUNTIME_C_FLAG}")

# rpath for the pkg-config meta-data.
set(_ginaclib_rpath "${_wl_rpath}${_ginac_rpath_reloc}")
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" isSystemDir)
if ("${isSystemDir}" STREQUAL "-1")
	list(APPEND _ginaclib_rpath "${_wl_rpath}\${libdir}")
endif()
set(GINACLIB_RPATH)
if (NOT CMAKE_SKIP_RPATH)
	if (_wl_rpath)
		set(GINACLIB_RPATH "${_ginaclib_rpath}")
	endif()
endif()

configure_file(${CMAKE_SOURCE_DIR}/ginac.pc.cmake ${CMAKE_BINARY_DIR}/ginac.pc @ONLY)
install(FILES ${CMAKE_BINARY_DIR}/ginac.pc DESTINATION "${LIB_INSTALL_DIR}/pkgconfig")

# rpath for libginac.so itself, ginsh, and friends
set(_ginac_rpath ${_ginac_rpath_reloc})
foreach(_d ${CLN_LIBRARY_DIRS} ${LIB_INSTALL_DIR})
	list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${_d}" isSystemDir)
	if ("${isSystemDir}" STREQUAL "-1")
		list(APPEND _ginac_rpath "${_d}")
	endif()
endforeach()
list(REMOVE_DUPLICATES _ginac_rpath)
string(REPLACE ";" ":" ginac_rpath "${_ginac_rpath}")

if (NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_RPATH)
	set(CMAKE_INSTALL_RPATH_USE_LINK_RPATH TRUE)
endif()
if (NOT DEFINED CMAKE_INSTALL_RPATH)
	set(CMAKE_INSTALL_RPATH ${ginac_rpath})
endif()
if (APPLE AND NOT DEFINED CMAKE_INSTALL_NAME_DIR)
	set(CMAKE_INSTALL_NAME_DIR ${LIB_INSTALL_DIR})
endif()

list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_INSTALL_DIR}" isSystemDir)
if ("${isSystemDir}" STREQUAL "-1")
	string(REPLACE ":" ";" _install_rpath "${CMAKE_INSTALL_RPATH}")
	list(FIND _install_rpath "${LIB_INSTALL_DIR}" _is_rpath_consistent)
	if ("${_is_rpath_consistent}" STREQUAL "-1")
		message(WARNING "the libginac.so library will be installed into "
				"a non-standard directory (${LIB_INSTALL_DIR}), "
				"however, the rpath (${_install_rpath}) "
				"does not contain that directory. Most likely "
				"things won't work without extra configuration "
				"(tweaking LD_LIBRARY_PATH, /etc/ld.so.conf, etc).")
	endif()
endif()


include(FindFLEX)
include(FindBISON)
find_package(BISON)
find_package(FLEX)
find_package(Readline)
if (READLINE_FOUND)
	set(HAVE_LIBREADLINE 1)
	set(HAVE_READLINE_READLINE_H 1)
	set(HAVE_READLINE_HISTORY_H 1)
endif()

find_program(MAKEINFO makeinfo)
find_program(FIG2DEV fig2dev)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_definitions(-DHAVE_CONFIG_H)

add_subdirectory(ginac)
add_subdirectory(tools)
add_subdirectory(check)
if (BISON_FOUND AND FLEX_FOUND)
	add_subdirectory(ginsh)
endif()
if (MAKEINFO)
	add_subdirectory(doc)
endif()

=== check/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ginac)
add_definitions(-DIN_GINAC)

set(ginac_tests
	check_numeric
	check_inifcns
	check_matrices
	check_lsolve
	check_mul_info
	heur_gcd_bug
	exam_paranoia
	exam_heur_gcd
	match_bug
	parser_bugs
	exam_numeric_archive
	exam_numeric
	exam_powerlaws
	exam_inifcns
	exam_inifcns_nstdsums
	exam_differentiation
	exam_polygcd
	exam_normalization
	exam_factor
	exam_pseries
	exam_matrices
	exam_lsolve
	exam_indexed
	exam_color
	exam_clifford
	exam_archive
	exam_structure
	exam_hashmap
	exam_misc
	exam_mod_gcd
	exam_cra
	bugme_chinrem_gcd
	factor_univariate_bug
	pgcd_relatively_prime_bug
	pgcd_infinite_loop)

set(ginac_timings
	time_dennyfliegner
	time_gammaseries
	time_vandermonde
	time_toeplitz
	time_hashmap
	time_lw_A
	time_lw_B
	time_lw_C
	time_lw_D
	time_lw_E
	time_lw_F
	time_lw_G
	time_lw_H
	time_lw_IJKL
	time_lw_M1
	time_lw_M2
	time_lw_N
	time_lw_O
	time_lw_P
	time_lw_Pprime
	time_lw_Q
	time_lw_Qprime
	time_antipode
	time_fateman_expand
	time_uvar_gcd
	time_parser)

macro(add_ginac_test thename)
	if ("${${thename}_sources}" STREQUAL "")
		set(${thename}_sources ${thename}.cpp ${${thename}_extra_src})
	endif()
	add_executable(${thename} EXCLUDE_FROM_ALL ${${thename}_sources})
	target_link_libraries(${thename} ginac)
	add_dependencies(check ${thename})
	add_test(NAME ${thename} COMMAND ${thename}${CMAKE_EXECUTABLE_SUFFIX})
endmacro()

macro(add_ginac_timing thename)
	set(${thename}_extra_src timer.cpp randomize_serials.cpp)
	add_ginac_test(${thename})
endmacro()

set(check_matrices_extra_src genex.cpp)
set(check_lsolve_extra_src genex.cpp)
set(exam_heur_gcd_sources heur_gcd_bug.cpp)
set(exam_numeric_archive_sources numeric_archive.cpp)

foreach(tst ${ginac_tests})
	add_ginac_test(${tst})
endforeach()

foreach(tmr ${ginac_timings})
	add_ginac_timing(${tmr})
endforeach()

=== ginsh/CMakeLists.txt ===
include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../ginac
	${CMAKE_CURRENT_BINARY_DIR}/../ginac
	${CMAKE_CURRENT_SOURCE_DIR}
	${CMAKE_CURRENT_BINARY_DIR})
add_definitions(-DIN_GINAC)

bison_target(ginsh_parser
             ginsh_parser.ypp
	     ${CMAKE_CURRENT_BINARY_DIR}/ginsh_parser.cpp)
flex_target(ginsh_lexer
            ginsh_lexer.lpp
	    ${CMAKE_CURRENT_BINARY_DIR}/ginsh_lexer.cpp)
add_flex_bison_dependency(ginsh_lexer ginsh_parser)

set(ginsh_SOURCES
    ginsh_parser.cpp
    ginsh_lexer.cpp
)

set(ginsh_HEADERS
    ginsh_parser.hpp
    ginsh.h
    ginsh_fcn_help.h
    ginsh_op_help.h
)

set(ginsh_DISTRIB
    ${ginsh_SOURCES}
    ${ginsh_HEADERS}
    ginsh_parser.ypp
    ginsh_lexer.lpp
    ginsh.1.in
    ginsh_fcn_help.py
    ginsh_op_help.py
)
if (READLINE_FOUND)
	include_directories(${READLINE_INCLUDE_DIRS})
endif()

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_fcn_help.h
	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py -o ginsh_fcn_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_op_help.h
	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py -o ginsh_op_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_parser.hpp
	DEPENDS ${BISON_ginsh_parser_OUTPUTS}
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

set(ginsh_extra_libs)
if (READLINE_FOUND)
	set(ginsh_extra_libs ${READLINE_LIBRARIES})
endif()

add_executable(ginsh ${ginsh_SOURCES} ${ginsh_HEADERS})
target_link_libraries(ginsh ginac ${ginsh_extra_libs})
install(TARGETS ginsh RUNTIME DESTINATION "${BIN_INSTALL_DIR}")

=== tools/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ginac)
add_definitions(-DIN_GINAC)

add_executable(viewgar viewgar.cpp)
target_link_libraries(viewgar ginac)
install(TARGETS viewgar RUNTIME DESTINATION "${BIN_INSTALL_DIR}")

## ginac 1.6.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -159,6 +159,11 @@
 	set(HAVE_READLINE_HISTORY_H 1)
 endif()
 
+find_package(LibDL)
+if (LIBDL_FOUND)
+	set(HAVE_LIBDL 1)
+endif()
+
 find_program(MAKEINFO makeinfo)
 find_program(FIG2DEV fig2dev)

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -71,7 +71,7 @@
 		set(${thename}_sources ${thename}.cpp ${${thename}_extra_src})
 	endif()
 	add_executable(${thename} EXCLUDE_FROM_ALL ${${thename}_sources})
-	target_link_libraries(${thename} ginac)
+	target_link_libraries(${thename} ginac ${LIBDL_LIBRARIES})
 	add_dependencies(check ${thename})
 	add_test(NAME ${thename} COMMAND ${thename}${CMAKE_EXECUTABLE_SUFFIX})
 endmacro()

=== ginac/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(ginaclib_sources
    add.cpp
    archive.cpp
    basic.cpp
    clifford.cpp
    color.cpp
    constant.cpp
    excompiler.cpp
    ex.cpp
    expair.cpp
    expairseq.cpp
    exprseq.cpp
    factor.cpp
    fail.cpp
    fderivative.cpp
    function.cpp
    idx.cpp
    indexed.cpp
    inifcns.cpp
    inifcns_gamma.cpp
    inifcns_nstdsums.cpp
    inifcns_trans.cpp
    integral.cpp
    lst.cpp
    matrix.cpp
    mul.cpp
    ncmul.cpp
    normal.cpp
    numeric.cpp
    operators.cpp
    parser/default_reader.cpp
    parser/lexer.cpp
    parser/parse_binop_rhs.cpp
    parser/parse_context.cpp
    parser/parser_compat.cpp
    parser/parser.cpp
    polynomial/chinrem_gcd.cpp
    polynomial/collect_vargs.cpp
    polynomial/cra_garner.cpp
    polynomial/divide_in_z_p.cpp
    polynomial/gcd_uvar.cpp
    polynomial/mgcd.cpp
    polynomial/mod_gcd.cpp
    polynomial/optimal_vars_finder.cpp
    polynomial/pgcd.cpp
    polynomial/primpart_content.cpp
    polynomial/upoly_io.cpp
    power.cpp
    print.cpp
    pseries.cpp
    registrar.cpp
    relational.cpp
    remember.cpp
    symbol.cpp
    symmetry.cpp
    tensor.cpp
    utils.cpp
    wildcard.cpp
)

set(ginaclib_public_headers
    ginac.h
    add.h
    archive.h
    assertion.h
    basic.h
    class_info.h
    clifford.h
    color.h
    constant.h
    container.h
    ex.h
    excompiler.h
    expair.h
    expairseq.h 
    exprseq.h
    fail.h
    factor.h
    fderivative.h
    flags.h
    ${CMAKE_CURRENT_BINARY_DIR}/function.h
    hash_map.h
    idx.h
    indexed.h 
    inifcns.h
    integral.h
    lst.h
    matrix.h
    mul.h
    ncmul.h
    normal.h
    numeric.h
    operators.h 
    power.h
    print.h
    pseries.h
    ptr.h
    registrar.h
    relational.h
    structure.h 
    symbol.h
    symmetry.h
    tensor.h
    version.h
    wildcard.h 
    parser/parser.h 
    parser/parse_context.h
)

set(ginaclib_private_headers
    remember.h
    tostring.h
    utils.h
    crc32.h
    hash_seed.h
    compiler.h
    parser/lexer.h
    parser/debug.h
    polynomial/gcd_euclid.h
    polynomial/remainder.h
    polynomial/normalize.h
    polynomial/upoly.h
    polynomial/ring_traits.h
    polynomial/mod_gcd.h
    polynomial/cra_garner.h
    polynomial/upoly_io.h
    polynomial/prem_uvar.h
    polynomial/eval_uvar.h
    polynomial/interpolate_padic_uvar.h
    polynomial/sr_gcd_uvar.h
    polynomial/heur_gcd_uvar.h
    polynomial/chinrem_gcd.h
    polynomial/collect_vargs.h
    polynomial/divide_in_z_p.h
    polynomial/euclid_gcd_wrap.h
    polynomial/eval_point_finder.h
    polynomial/newton_interpolate.h
    polynomial/optimal_vars_finder.h
    polynomial/pgcd.h
    polynomial/poly_cra.h
    polynomial/primes_factory.h
    polynomial/smod_helpers.h
    polynomial/debug.h
)

add_library(ginac ${ginaclib_sources})
set_target_properties(ginac PROPERTIES
	SOVERSION ${ginaclib_soversion}
	VERSION ${ginaclib_version})
target_link_libraries(ginac ${CLN_LIBRARIES})
include_directories(${CMAKE_SOURCE_DIR}/ginac)

if (NOT BUILD_SHARED_LIBS)
	set_target_properties(ginac PROPERTIES OUTPUT_NAME "ginac")
	# Avoid the static library vs import library conflict (necessary for
	# m$ toolchain).
	set_target_properties(ginac PROPERTIES PREFIX "lib")
endif()

install(TARGETS ginac LIBRARY DESTINATION "${LIB_INSTALL_DIR}"
		      RUNTIME DESTINATION "${BIN_INSTALL_DIR}"
		      ARCHIVE DESTINATION "${LIB_INSTALL_DIR}")
install(FILES ${ginaclib_public_headers} DESTINATION "${INCLUDE_INSTALL_DIR}/ginac")

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/function.h
	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/function.py -o ${CMAKE_CURRENT_BINARY_DIR}/function.h ${CMAKE_CURRENT_SOURCE_DIR}/function.hppy
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/function.hppy ${CMAKE_CURRENT_SOURCE_DIR}/function.py)

add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/function.cpp
	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/function.py -o ${CMAKE_CURRENT_BINARY_DIR}/function.cpp ${CMAKE_CURRENT_SOURCE_DIR}/function.cppy
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/function.h ${CMAKE_CURRENT_SOURCE_DIR}/function.cppy ${CMAKE_CURRENT_SOURCE_DIR}/function.py)

=== tools/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../ginac)
add_definitions(-DIN_GINAC)

add_executable(viewgar viewgar.cpp)
target_link_libraries(viewgar ginac ${LIBDL_LIBRARIES})
install(TARGETS viewgar RUNTIME DESTINATION "${BIN_INSTALL_DIR}")

if (CMAKE_COMPILER_IS_GNUCC)
	set (CC gcc)
	configure_file (
          "${CMAKE_CURRENT_SOURCE_DIR}/ginac-excompiler.in"
          "${CMAKE_CURRENT_BINARY_DIR}/ginac-excompiler"
	)

	install(PROGRAMS ginac-excompiler DESTINATION "${BIN_INSTALL_DIR}")
endif  (CMAKE_COMPILER_IS_GNUCC)

=== doc/examples/CMakeLists.txt ===
add_info_file(ginac-examples)

## ginac 1.7.4

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 	exam_misc
 	exam_mod_gcd
 	exam_cra
+	exam_real_imag
 	bugme_chinrem_gcd
 	factor_univariate_bug
 	pgcd_relatively_prime_bug

=== ginsh/CMakeLists.txt ===
--- 
+++ 
@@ -61,5 +61,5 @@
 endif()
 
 add_executable(ginsh ${ginsh_SOURCES} ${ginsh_HEADERS})
-target_link_libraries(ginsh ginac ${ginsh_extra_libs})
+target_link_libraries(ginsh ginac ${ginsh_extra_libs} ${LIBDL_LIBRARIES})
 install(TARGETS ginsh RUNTIME DESTINATION "${BIN_INSTALL_DIR}")

## ginac 1.7.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.6)
+cmake_minimum_required(VERSION 3.1)
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")
 
 project(GiNaC)
@@ -25,11 +25,12 @@
 add_custom_target(html)
 add_custom_target(pdf)
 
+set (CMAKE_CXX_STANDARD 11)
+
 find_package(CLN 1.2.2 REQUIRED)
 include_directories(${CLN_INCLUDE_DIR})
 
 include(CheckIncludeFile)
-check_include_file("stdint.h" HAVE_STDINT_H)
 check_include_file("unistd.h" HAVE_UNISTD_H)
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/ginac)
@@ -170,6 +171,10 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h)
 add_definitions(-DHAVE_CONFIG_H)
 
+if (NOT LIBEXECDIR)
+	set (LIBEXECDIR "${CMAKE_INSTALL_PREFIX}/libexec")
+endif()
+
 add_subdirectory(ginac)
 add_subdirectory(tools)
 add_subdirectory(check)

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,6 @@
 	exam_clifford
 	exam_archive
 	exam_structure
-	exam_hashmap
 	exam_misc
 	exam_mod_gcd
 	exam_cra
@@ -44,7 +43,6 @@
 	time_gammaseries
 	time_vandermonde
 	time_toeplitz
-	time_hashmap
 	time_lw_A
 	time_lw_B
 	time_lw_C

=== doc/CMakeLists.txt ===
find_package(Doxygen)
find_program(FIG2DEV fig2dev)
find_program(TEXI2DVI texi2dvi)
find_package(LATEX)
if (PDFLATEX_COMPILER AND MAKEINDEX_COMPILER)
	set(LATEX_FOUND true)
endif()

macro(add_info_file thename)
	set(${thename}_INFO ${CMAKE_CURRENT_BINARY_DIR}/${thename}.info)
	set(${thename}_HTML ${CMAKE_CURRENT_BINARY_DIR}/${thename}.html)
	set(${thename}_TEXINFO ${CMAKE_CURRENT_SOURCE_DIR}/${thename}.texi)
	add_custom_command(
		OUTPUT ${${thename}_INFO}
		COMMAND ${MAKEINFO} --no-split -o ${${thename}_INFO} ${${thename}_TEXINFO}
		DEPENDS ${${thename}_TEXINFO}
		COMMENT "MAKEFINO ${thename}.texi"
		VERBATIM)
	add_custom_command(
		OUTPUT ${${thename}_HTML}
		COMMAND ${MAKEINFO} --html --no-split -o ${${thename}_HTML} ${${thename}_TEXINFO}
		DEPENDS ${${thename}_TEXINFO} ${${thename}_HTML_EXTRA_DEPS}
		COMMENT "MAKEINFOHTML ${thename}.texi"
		VERBATIM)
	add_custom_target(${thename}_info ALL DEPENDS ${${thename}_INFO})
	add_custom_target(${thename}_html DEPENDS ${${thename}_HTML})
	add_dependencies(info ${thename}_info)
	add_dependencies(html ${thename}_html)
	install(FILES ${${thename}_INFO} DESTINATION "${SHARE_INSTALL_PREFIX}/info")
endmacro()

macro(pdflatex_process texfile)
	get_filename_component(_dirname "${texfile}" PATH)
	get_filename_component(_basename "${texfile}" NAME_WE)
	set(_idx ${_dirname}/${_basename}.idx)
	set(_ind ${_dirname}/${_basename}.ind)
	set(_pdf ${_dirname}/${_basename}.pdf)
	set(_fixupind ${CMAKE_SOURCE_DIR}/scripts/fixupind.py)
	add_custom_command(
		OUTPUT ${_idx}
		COMMAND ${PDFLATEX_COMPILER} ${texfile}
		WORKING_DIRECTORY ${_dirname}
		DEPENDS ${texfile}
		COMMENT "PDFLATEX ${_basename}.tex (1)")
	add_custom_command(
		OUTPUT ${_ind}
		COMMAND ${MAKEINDEX_COMPILER} ${_idx}
		COMMAND python ${_fixupind} ${_idx}
		WORKING_DIRECTORY ${_dirname}
		DEPENDS ${texfile} ${_idx}
		COMMENT "MAKEINDEX ${_basename}.idx")
	add_custom_command(
		OUTPUT ${_pdf}
		COMMAND ${PDFLATEX_COMPILER} ${texfile}
		WORKING_DIRECTORY ${_dirname}
		DEPENDS ${texfile} ${_ind}
		COMMENT "PDFLATEX ${_basename}.tex (2)")
endmacro()

add_subdirectory(tutorial)
add_subdirectory(examples)
if (DOXYGEN_FOUND)
	add_subdirectory(reference)
endif()

=== ginac/CMakeLists.txt ===
--- 
+++ 
@@ -43,9 +43,11 @@
     polynomial/gcd_uvar.cpp
     polynomial/mgcd.cpp
     polynomial/mod_gcd.cpp
+    polynomial/normalize.cpp
     polynomial/optimal_vars_finder.cpp
     polynomial/pgcd.cpp
     polynomial/primpart_content.cpp
+    polynomial/remainder.cpp
     polynomial/upoly_io.cpp
     power.cpp
     print.cpp
@@ -69,6 +71,7 @@
     class_info.h
     clifford.h
     color.h
+    compiler.h
     constant.h
     container.h
     ex.h
@@ -111,11 +114,9 @@
 
 set(ginaclib_private_headers
     remember.h
-    tostring.h
     utils.h
     crc32.h
     hash_seed.h
-    compiler.h
     parser/lexer.h
     parser/debug.h
     polynomial/gcd_euclid.h
@@ -146,6 +147,7 @@
 )
 
 add_library(ginac ${ginaclib_sources})
+add_definitions(-DLIBEXECDIR="${LIBEXECDIR}/")
 set_target_properties(ginac PROPERTIES
 	SOVERSION ${ginaclib_soversion}
 	VERSION ${ginaclib_version})

=== ginsh/CMakeLists.txt ===
--- 
+++ 
@@ -40,13 +40,13 @@
 
 add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_fcn_help.h
-	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py -o ginsh_fcn_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
+	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py -o ginsh_fcn_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py
 	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
 
 add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_op_help.h
-	COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py -o ginsh_op_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
+	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py -o ginsh_op_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py
 	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -12,5 +12,5 @@
           "${CMAKE_CURRENT_BINARY_DIR}/ginac-excompiler"
 	)
 
-	install(PROGRAMS ginac-excompiler DESTINATION "${BIN_INSTALL_DIR}")
-endif  (CMAKE_COMPILER_IS_GNUCC)
+	install(PROGRAMS ginac-excompiler DESTINATION "${LIBEXECDIR}")
+endif (CMAKE_COMPILER_IS_GNUCC)

=== doc/reference/CMakeLists.txt ===
set(VERSION ${GINAC_VERSION})
set(top_srcdir ${CMAKE_SOURCE_DIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DoxyfileHTML.in
	       ${CMAKE_CURRENT_BINARY_DIR}/DoxyfileHTML
	       @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DoxyfilePDF.in
	       ${CMAKE_CURRENT_BINARY_DIR}/DoxyfilePDF
	       @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DoxyfileTEX.in
	       ${CMAKE_CURRENT_BINARY_DIR}/DoxyfileTEX
	       @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfooter.in
	       ${CMAKE_CURRENT_BINARY_DIR}/Doxyfooter
	       @ONLY)

add_custom_target(html_dox
	COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/DoxyfileHTML
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "DOXYGEN DoxyfileHTML")
add_dependencies(html html_dox)
add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pdflatex/refman.tex
	COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/DoxyfilePDF
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "DOXYGEN DoxyfilePDF")
add_custom_command(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pdflatex/reference.tex
	COMMAND ${CMAKE_COMMAND} -E copy refman.tex reference.tex
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/pdflatex/refman.tex
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/pdflatex)


if (LATEX_FOUND)
	pdflatex_process(${CMAKE_CURRENT_BINARY_DIR}/pdflatex/reference.tex)
	add_custom_target(pdf_dox DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/pdflatex/reference.pdf)
	add_dependencies(pdf pdf_dox)
endif()

## ginac 1.7.9

=== debian/changelog ===
ginac (1.7.9-1) unstable; urgency=low

  * New upstream release.
  * Re-debianize the package from scratch:
    + Bump debhelper compat to 12, but not debhelper depends to allow backports.
    + Replace debian/rules with simpler file, using dh.
    + Install in the multiarch libdir /usr/lib/<triplet>/, to allow for cross
      builds of reverse dependencies.

 -- Richard B. Kreckel <kreckel@debian.org>  Wed, 15 Apr 2020 22:01:32 +0100

ginac (1.7.8-2) unstable; urgency=low

  * Reduce dependencies of -dev package.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 09 Nov 2019 19:53:27 +0100

ginac (1.7.8-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 07 Oct 2019 22:32:35 +0200

ginac (1.7.7-1) unstable; urgency=low

  * New upstream release.
  * Change build-depend to python3; closes: #936613.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 23 Sep 2019 20:57:13 +0200

ginac (1.7.6-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 26 Jul 2019 20:51:50 +0200

ginac (1.7.5-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 17 Feb 2019 15:32:27 +0100

ginac (1.7.4-2) unstable; urgency=low

  * Add build-depend on texinfo; closes: #906777.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 09 Sep 2018 11:56:16 +0200

ginac (1.7.4-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 19 Feb 2018 23:43:31 +0100

ginac (1.7.3-1) experimental; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Thu, 01 Feb 2018 20:05:15 +0100

ginac (1.7.2-2) unstable; urgency=low

  * Re-upload targeting testing.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 16 Jan 2017 23:15:41 +0100

ginac (1.7.2-1) experimental; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Tue, 10 Jan 2017 07:12:13 +0200

ginac (1.7.1-2) unstable; urgency=low

  * Replaced libreadline6-dev build dependency with libreadline-dev.

 -- Richard B. Kreckel <kreckel@debian.org>  Thu, 13 Oct 2016 21:54:43 +0200

ginac (1.7.1-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 02 Oct 2016 14:21:12 +0200

ginac (1.7.0-2) unstable; urgency=low

  * Trigger recompilation with gcc-6 default; closes: #830532.

 -- Richard B. Kreckel <kreckel@debian.org>  Tue, 09 Aug 2016 21:58:47 +0100

ginac (1.7.0-1) unstable; urgency=low

  * New upstream release: binary incompatible, requires C++11,
    new soname versioning, so it's libginac6 now.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 25 Jun 2016 13:14:15 +0200

ginac (1.6.7-1) unstable; urgency=low

  * New upstream release.
  * Drop -dbg package, now that dbgsym package is built automatically.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 29 Feb 2016 15:49:53 +0100

ginac (1.6.6-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 01 Jan 2016 15:49:53 +0100

ginac (1.6.5-1) unstable; urgency=low

  * New upstream release.
  * Remove support for Debian menu system.

 -- Richard B. Kreckel <kreckel@debian.org>  Wed, 30 Sep 2015 23:42:21 +0200

ginac (1.6.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Steve Langasek ]
  * Rename library packages for g++5 ABI transition. (Closes: #791048)

  [ Simon McVittie ]
  * Also update debian/rules so that libginac5v5-dbg is non-empty

 -- Simon McVittie <smcv@debian.org>  Mon, 21 Sep 2015 07:56:10 +0100

ginac (1.6.4-1) unstable; urgency=low

  * New upstream release; binary incompatible, new soname versioning,
    so it's libginac5 now.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 08 May 2015 22:43:23 +0200

ginac (1.6.3-3) unstable; urgency=low

  * Add build-dependency on python.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 30 Nov 2014 10:16:49 +0100

ginac (1.6.3-2) unstable; urgency=low

  * Add build-dependency on dh-autoreconf.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 29 Nov 2014 21:55:14 +0100

ginac (1.6.3-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 28 Nov 2014 23:58:07 +0100

ginac (1.6.3~20140816-1) experimental; urgency=low

  * Upstream prerelease; binary incompatible, new soname versioning,
  * Use dh-autoreconf to fix FTBFS on ppc64el; closes: #733477.

 -- Richard Kreckel <kreckel@ginac.de>  Sat, 16 Aug 2014 20:32:43 +0200

ginac (1.6.2-1) unstable; urgency=low

  * New upstream (bugfix only) release.

 -- Richard Kreckel <kreckel@ginac.de>  Fri, 11 Nov 2011 11:11:11 +0200

ginac (1.6.1-1) unstable; urgency=low

  * New upstream (bugfix only) release.

 -- Richard Kreckel <kreckel@ginac.de>  Wed, 21 Jul 2011 21:55:28 +0200

ginac (1.6.0-1) unstable; urgency=low

  * New upstream release; binary incompatible, new soname versioning,
    so it's libginac2 now; closes: #479163.
  * Provide ginac-excompiler as part of ginac-tools; closes: #592674.
  * Get rid of unneeded libginac.la file; closes: #621302.

 -- Richard Kreckel <kreckel@ginac.de>  Tue, 24 May 2011 21:36:50 +0200

ginac (1.5.8-1) unstable; urgency=low

  * New upstream (bugfix only) release.

 -- Richard Kreckel <kreckel@ginac.de>  Tue, 06 Jul 2010 21:25:15 +0200

ginac (1.5.7-1) unstable; urgency=low

  * New upstream (bugfix only) release.
  * Removed -finline-limit=1200 from CXXFLAGS, as benchmarking did not
    demonstrate that this option makes a difference (at least ond amd64).

 -- Richard Kreckel <kreckel@ginac.de>  Mon, 29 Mar 2010 23:36:37 +0200

ginac (1.5.6-1) unstable; urgency=low

  * New upstream (bugfix only) release.

 -- Richard Kreckel <kreckel@ginac.de>  Sun, 31 Jan 2010 21:22:41 +0100

ginac (1.5.5-1) unstable; urgency=low

  * New upstream (bugfix only) release.

 -- Richard Kreckel <kreckel@ginac.de>  Wed,  4 Oct 2009 22:32:50 +0100

ginac (1.5.4-1) unstable; urgency=low



=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

#include /usr/share/cdbs/1/class/autotools.mk
#include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/rules/autoreconf.mk

#GINACLIB_VERSION := 6
#GINACLIB := libginac$(GINACLIB_VERSION)

#DEB_CONFIGURE_EXTRA_FLAGS := --disable-rpath

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --libexecdir='$${libdir}/ginac'

override_dh_installchangelogs:
	dh_installchangelogs --exclude=ChangeLog

override_dh_installdocs:
	dh_installdocs -- NEWS README AUTHORS

## ginac 1.7.10

=== debian/changelog ===
ginac (1.7.10-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 28 Jun 2020 20:14:33 +0200

=== debian/watch ===
version=3
http://www.ginac.de/Download.html ginac-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## ginac 1.7.11

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,6 @@
 	check_inifcns
 	check_matrices
 	check_lsolve
-	check_mul_info
 	heur_gcd_bug
 	exam_paranoia
 	exam_heur_gcd
@@ -19,6 +18,7 @@
 	exam_inifcns_nstdsums
 	exam_differentiation
 	exam_polygcd
+	exam_collect_common_factors
 	exam_normalization
 	exam_factor
 	exam_pseries
@@ -34,7 +34,6 @@
 	exam_cra
 	exam_real_imag
 	bugme_chinrem_gcd
-	factor_univariate_bug
 	pgcd_relatively_prime_bug
 	pgcd_infinite_loop)

=== debian/changelog ===
ginac (1.7.11-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 03 Aug 2020 20:46:53 +0200

=== debian/control ===
Source: ginac
Section: math
Priority: optional
Maintainer: Richard Kreckel <kreckel@ginac.de>
Build-Depends: cdbs (>= 0.4.28), debhelper (>= 9), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, dh-autoreconf, python3, texinfo
Standards-Version: 4.5.0
Homepage: http://www.ginac.de/

Package: libginac6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: ginac-tools
Description: GiNaC symbolic framework runtime library
 GiNaC (which stands for "GiNaC is Not a CAS (Computer Algebra System)") is a
 library for doing symbolic (i.e. non-numeric) computation directly in the C++
 programming language.
 .
 This package provides the runtime library.

Package: libginac-dev
Architecture: any
Section: libdevel
Depends: libginac6 (= ${binary:Version}), ${misc:Depends}, libcln-dev
Recommends: info | info-browser
Suggests: ginac-tools
Description: GiNaC symbolic framework development files
 GiNaC (which stands for "GiNaC is Not a CAS (Computer Algebra System)") is a
 library for doing symbolic (i.e. non-numeric) computation directly in the C++
 programming language.
 .
 This package provides header files, a static library plus a tutorial as info
 file.

Package: ginac-tools
Architecture: any
Section: math
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: doc-base
Description: GiNaC symbolic framework support tools
 GiNaC (which stands for "GiNaC is Not a CAS (Computer Algebra System)") is a
 library for doing symbolic (i.e. non-numeric) computation directly in the C++
 programming language.
 .
 This package provides some additional tools, like the popular ginsh (GiNaC
 interactive shell) and viewgar (for inspecting GiNaC archive files).

## ginac 1.8.0

=== check/CMakeLists.txt ===

set(ginac_exams
	exam_paranoia
	exam_heur_gcd
	exam_match
	exam_parser
	exam_numeric
	exam_powerlaws
	exam_inifcns
	exam_inifcns_nstdsums
	exam_inifcns_elliptic
	exam_differentiation
	exam_polygcd
	exam_collect_common_factors
	exam_normalization
	exam_sqrfree
	exam_factor
	exam_pseries
	exam_matrices
	exam_lsolve
	exam_indexed
	exam_color
	exam_clifford
	exam_archive
	exam_structure
	exam_misc
	exam_pgcd
	exam_mod_gcd
	exam_real_imag
	exam_chinrem_gcd)

set(ginac_checks
	check_numeric
	check_inifcns
	check_matrices
	check_lsolve
	check_cra)

set(ginac_timings
	time_dennyfliegner
	time_gammaseries
	time_vandermonde
	time_toeplitz
	time_lw_A
	time_lw_B
	time_lw_C
	time_lw_D
	time_lw_E
	time_lw_F
	time_lw_G
	time_lw_H
	time_lw_IJKL
	time_lw_M1
	time_lw_M2
	time_lw_N
	time_lw_O
	time_lw_P
	time_lw_Pprime
	time_lw_Q
	time_lw_Qprime
	time_antipode
	time_fateman_expand
	time_uvar_gcd
	time_parser)

macro(add_ginac_test thename)
	if ("${${thename}_sources}" STREQUAL "")
		set(${thename}_sources ${thename}.cpp ${${thename}_extra_src})
	endif()
	add_executable(${thename} EXCLUDE_FROM_ALL ${${thename}_sources})
	target_link_libraries(${thename} ginac::ginac)
	add_dependencies(test_suite ${thename})
	add_dependencies(check ${thename})
	add_test(NAME ${thename} COMMAND $<TARGET_FILE:${thename}>)
endmacro()

macro(add_ginac_timing thename)
	set(${thename}_extra_src timer.cpp randomize_serials.cpp)
	add_ginac_test(${thename})
	target_compile_definitions(${thename} PRIVATE HAVE_CONFIG_H)
endmacro()

set(check_matrices_extra_src genex.cpp)
set(check_lsolve_extra_src genex.cpp)

foreach(exm ${ginac_exams})
	add_ginac_test(${exm})
endforeach()

foreach(chk ${ginac_checks})
	add_ginac_test(${chk})
endforeach()

foreach(tmr ${ginac_timings})
	add_ginac_timing(${tmr})
endforeach()

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -26,7 +26,7 @@
 	add_custom_target(${thename}_html DEPENDS ${${thename}_HTML})
 	add_dependencies(info ${thename}_info)
 	add_dependencies(html ${thename}_html)
-	install(FILES ${${thename}_INFO} DESTINATION "${SHARE_INSTALL_PREFIX}/info")
+	install(FILES ${${thename}_INFO} DESTINATION "${CMAKE_INSTALL_PREFIX}/share/info")
 endmacro()
 
 macro(pdflatex_process texfile)
@@ -45,7 +45,7 @@
 	add_custom_command(
 		OUTPUT ${_ind}
 		COMMAND ${MAKEINDEX_COMPILER} ${_idx}
-		COMMAND python ${_fixupind} ${_idx}
+		COMMAND ${PYTHON} ${_fixupind} ${_idx}
 		WORKING_DIRECTORY ${_dirname}
 		DEPENDS ${texfile} ${_idx}
 		COMMENT "MAKEINDEX ${_basename}.idx")

=== debian/changelog ===
ginac (1.8.0-2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Helmut Grohne ]
  * Fix FTCBFS: Annotate python3 build dependency with :any. (Closes: #974105)

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 09 Nov 2020 23:47:12 +0100

ginac (1.8.0-1) unstable; urgency=low

  * New upstream release: binary incompatible, so it's libginac11 now.

 -- Richard B. Kreckel <kreckel@debian.org>  Thu, 15 Oct 2020 20:26:41 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: math
 Priority: optional
 Maintainer: Richard Kreckel <kreckel@ginac.de>
-Build-Depends: cdbs (>= 0.4.28), debhelper (>= 9), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, dh-autoreconf, python3, texinfo
+Build-Depends: cdbs (>= 0.4.28), debhelper (>= 9), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
 Standards-Version: 4.5.0
 Homepage: http://www.ginac.de/
 
-Package: libginac6
+Package: libginac11
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -21,7 +21,7 @@
 Package: libginac-dev
 Architecture: any
 Section: libdevel
-Depends: libginac6 (= ${binary:Version}), ${misc:Depends}, libcln-dev
+Depends: libginac11 (= ${binary:Version}), ${misc:Depends}, libcln-dev
 Recommends: info | info-browser
 Suggests: ginac-tools
 Description: GiNaC symbolic framework development files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --libexecdir='$${libdir}/ginac'

override_dh_installchangelogs:
	dh_installchangelogs --exclude=ChangeLog

override_dh_installdocs:
	dh_installdocs -- NEWS README AUTHORS

## ginac 1.8.1

=== debian/changelog ===
ginac (1.8.1-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 15 Aug 2021 14:45:44 +0200

## ginac 1.8.2

=== debian/changelog ===
ginac (1.8.2-3) unstable; urgency=low

  * Configure with --disable-rpath, so dependent packages don't get lintian
    error 'custom-library-search-path'.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 20 Feb 2022 20:43:32 +0100

ginac (1.8.2-2) unstable; urgency=low

  * Apply upstream fix for exam_inifcns_nstdsums to see if it fixes a recent
    FTBFS on mipsel.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 15 Jan 2022 10:06:47 +0100

ginac (1.8.2-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 01 Jan 2022 18:57:31 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Richard Kreckel <kreckel@ginac.de>
 Build-Depends: cdbs (>= 0.4.28), debhelper (>= 9), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0.1
 Homepage: http://www.ginac.de/
 
 Package: libginac11

=== debian/watch ===
version=3
https://www.ginac.de/Download.html ginac-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## ginac 1.8.3

=== debian/changelog ===
ginac (1.8.3-3) unstable; urgency=low

  * Make debian/not-installed portable to other archs, sigh.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 22 Apr 2022 19:09:53 +0200

ginac (1.8.3-2) unstable; urgency=low

  * Add debian/not-installed file.
  * Specify debhelper-compat (= 13) as Build-Deponds, and remove the
    debian/compat file.
  * Upgrade debian/watch file to version 4.
  * Drop Build-Depends on cdbs.
  * Do not duplicate named field Section: math inherited from source package
    ginac in installation package ginac-tools.

 -- Richard B. Kreckel <kreckel@debian.org>  Fri, 22 Apr 2022 12:22:13 +0200

ginac (1.8.3-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Wed, 23 Mar 2022 22:19:43 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: math
 Priority: optional
 Maintainer: Richard Kreckel <kreckel@ginac.de>
-Build-Depends: cdbs (>= 0.4.28), debhelper (>= 9), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
-Standards-Version: 4.6.0.1
+Build-Depends: debhelper-compat (= 13), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
+Standards-Version: 4.6.0
 Homepage: http://www.ginac.de/
 
 Package: libginac11
@@ -34,7 +34,6 @@
 
 Package: ginac-tools
 Architecture: any
-Section: math
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: doc-base
 Description: GiNaC symbolic framework support tools

## ginac 1.8.4

=== debian/changelog ===
ginac (1.8.4-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Mon, 19 Sep 2022 10:48:58 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Richard Kreckel <kreckel@ginac.de>
 Build-Depends: debhelper-compat (= 13), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: http://www.ginac.de/
 
 Package: libginac11

## ginac 1.8.5

=== debian/changelog ===
ginac (1.8.5-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sun, 01 Jan 2023 14:59:51 +0100

## ginac 1.8.6

=== ginsh/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,3 @@
-include_directories(
-	${CMAKE_CURRENT_SOURCE_DIR}/../ginac
-	${CMAKE_CURRENT_BINARY_DIR}/../ginac
-	${CMAKE_CURRENT_SOURCE_DIR}
-	${CMAKE_CURRENT_BINARY_DIR})
-add_definitions(-DIN_GINAC)
 
 bison_target(ginsh_parser
              ginsh_parser.ypp
@@ -34,19 +28,20 @@
     ginsh_fcn_help.py
     ginsh_op_help.py
 )
+set(ginsh_include_directories ${CMAKE_CURRENT_BINARY_DIR}/.. ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
 if (READLINE_FOUND)
-	include_directories(${READLINE_INCLUDE_DIRS})
+	set(ginsh_include_directories ${ginsh_include_directories} ${READLINE_INCLUDE_DIRS})
 endif()
 
 add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_fcn_help.h
-	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py -o ginsh_fcn_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
+	COMMAND ${PYTHON} ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py -o ginsh_fcn_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_fcn_help.py
 	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
 
 add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ginsh_op_help.h
-	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py -o ginsh_op_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
+	COMMAND ${PYTHON} ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py -o ginsh_op_help.h ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in
 	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/ginsh.1.in ${CMAKE_CURRENT_SOURCE_DIR}/ginsh_op_help.py
 	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
 
@@ -61,5 +56,7 @@
 endif()
 
 add_executable(ginsh ${ginsh_SOURCES} ${ginsh_HEADERS})
-target_link_libraries(ginsh ginac ${ginsh_extra_libs} ${LIBDL_LIBRARIES})
-install(TARGETS ginsh RUNTIME DESTINATION "${BIN_INSTALL_DIR}")
+target_link_libraries(ginsh ginac::ginac ${ginsh_extra_libs})
+target_include_directories(ginsh PRIVATE ${ginsh_include_directories})
+target_compile_definitions(ginsh PRIVATE HAVE_CONFIG_H)
+install(TARGETS ginsh RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== debian/changelog ===
ginac (1.8.6-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Wed, 08 Feb 2023 22:51:12 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Richard Kreckel <kreckel@ginac.de>
 Build-Depends: debhelper-compat (= 13), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: http://www.ginac.de/
 
 Package: libginac11

## ginac 1.8.7

=== debian/changelog ===
ginac (1.8.7-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:47:17 +0000

ginac (1.8.7-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:54:39 +0100

ginac (1.8.7-1) unstable; urgency=low

  * New upstream release.

 -- Richard B. Kreckel <kreckel@debian.org>  Sat, 12 Aug 2023 18:23:47 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: ginac
 Section: math
 Priority: optional
-Maintainer: Richard Kreckel <kreckel@ginac.de>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Richard Kreckel <kreckel@ginac.de>
 Build-Depends: debhelper-compat (= 13), libcln-dev, libgmp-dev, libreadline-dev, pkg-config (>= 0.18) | pkgconf, python3:any, texinfo
 Standards-Version: 4.6.2
 Homepage: http://www.ginac.de/
